CREATE DATABASE [ApplicationTraceDB]
GO

USE [ApplicationTraceDB]
GO

CREATE TABLE [Trace] (
	[Id] 			[bigint] 	IDENTITY (1, 1) NOT NULL PRIMARY KEY CLUSTERED,
	[TraceDate] 		[datetime] 	NOT NULL ,
	[TraceCategory] 	[varchar] (20) 	COLLATE Turkish_CI_AS NULL ,
	[TraceDescription] 	[varchar] (1024) COLLATE Turkish_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE PROCEDURE Trace_INSERT 
(
@TraceCategory 		VARCHAR(20),
@TraceDescription 	VARCHAR(1024)
)
AS
INSERT INTO Trace
(TraceDate, TraceCategory, TraceDescription)
VALUES 
(GetDate(), @TraceCategory, @TraceDescription)
GO

CREATE PROCEDURE Trace_SELECT_ByCategory 
(
@TraceCategory 		VARCHAR(20)
)
AS
SELECT [TraceDate], [TraceDescription]
FROM [Trace]
WHERE 
[TraceCategory] = @TraceCategory
GO

sp_addlogin 'TraceUser' , 'TrAcEuSeR', 'ApplicationTraceDB'
GO

sp_adduser 'TraceUser', 'TraceUser'
GO

GRANT INSERT, SELECT ON Trace TO TraceUser
GO

GRANT EXECUTE ON Trace_INSERT TO TraceUser
GO

GRANT EXECUTE ON Trace_SELECT_ByCategory TO TraceUser
GO
